"""
Computational geometry utility functions.
"""

def point_in_box(x, y, x1, y1, width, height):
    """
    Determines if the given point x, y is in the
    box defined by x1, y1 with width and height.
    Note that this looks for inside the box, not
    on the box border.
    """
    if x1 < x < (x1 + width) and \
            y1 < y < (y1 + height):
        return True
    return False

def four_corners(sprite):
    return ((sprite.x, sprite.y), \
                (sprite.x + sprite.width, sprite.y), \
                (sprite.x, sprite.y + sprite.height), \
                (sprite.x + sprite.width, sprite.y + sprite.height))
