import PyQt4
from PyQt4 import QtGui
from PyQt4.QtGui import QDialog
from PyQt4.QtGui import QListWidget
from PyQt4.QtGui import QPushButton
from PyQt4.QtGui import QHBoxLayout
from PyQt4.QtGui import QVBoxLayout
from PyQt4.QtCore import QString

import glob
import os
import sys


def find_map_names(map_dir):
    map_filenames = glob.glob(map_dir + os.sep + "map*.map")
    map_names = []
    for filename in map_filenames:
        s = filename.rfind("/") + 1
        e = filename.rfind(".")
        map_names.append(filename[s:e])
    # file system doesn't guarantee that file names will be sorted
    map_names.sort()
    return map_names


class TeleportDialog(QDialog):
    def __init__(self, map_names):
        super(TeleportDialog, self).__init__()

        button_layout = QHBoxLayout()
        ok_button = QPushButton("Select", self)
        ok_button.clicked.connect(self.accept)
        cancel_button = QPushButton("Cancel", self)
        cancel_button.clicked.connect(self.reject)
        button_layout.addWidget(ok_button)
        button_layout.addWidget(cancel_button)

        window_layout = QVBoxLayout()
        self.map_list = QListWidget(self)
        for name in map_names:
            self.map_list.addItem(QString(name))
        self.map_list.setCurrentRow(0)
        window_layout.addWidget(self.map_list)
        window_layout.addLayout(button_layout)

        self.setLayout(window_layout)

        self.setWindowTitle("Select Teleport Destination")

    def get_selected_item(self):
        widget_item = self.map_list.currentItem()
        selected_map_name = widget_item.text()
        return selected_map_name

if __name__ == "__main__":
    map_dir = sys.argv[1]
    map_names = find_map_names(map_dir)

    app = QtGui.QApplication(sys.argv)
    window = TeleportDialog(map_names)

    if window.exec_():
        selected_map_name = window.get_selected_item()
        print "Selected " + selected_map_name
    else:
        print "Canceled"
